// AVRUP V1 was derived from a stripped down version of my Developer's Terminal
// Many of the concepts herein are discussed in 'Virtual Serial Port Cookbook'
// that you can buy on www.smileymicros.com. 
//
// AVRUP V1 is evolving over time and like many a creature of evolution, 
// you might find some atavistic artifacts. As my Grandpappy, the hog 
// farmer, used to say: "That's about as useful as tits an a boar." Well,
// I'm going to guess that you'll find some artifacts in this code that 
// are even less useful.
// 
// Start Legal>
// Don't you just love the legalistic bullshit that is usually inserted
// at this point? I've rewritten some standard boilerplate stuff to say what
// I think we really mean:
//  This work is entirely by Joe Pardue (except for the major portions he
//  stole and forgot to attribute). 
//
//  This software is not warrented in any way what-so-ever. It WILL screw
//  something up and will kill someone after doing serious property
//  damage. 
//
//  YOU'VE BEEN WARNED - DON'T USE THIS CODE UNDER ANY CIRCUMSTANCES!
//
//  <End Legal
//
// If you have any bug reports, comments, or concerns please start a 
// thread on the off-topics forum of www.AVRFreaks.net. If you are not
// familiar with AVRFreaks then please (please!) read the sticky thread 
// at the top of the AVRFreaks AVR forum: Newbie? Start Here!
// http://www.avrfreaks.net/index.php?name=PNphpBB2&file=viewtopic&t=70673
// I consider my public work part of a community effort. Any questions
// you might have - someone else might also have - so discussing it 
// once in public where it will be available to others will save 
// everyone a lot of time. For this reason, I will not answer any
// private questions, unless you want to have my baby...
//
// AND one last thing - V1 for [REDACTED], and some other boards TBD.
// You will find some code commented out that I was testing for V2 while
// writing V1.
//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.IO.Ports;
using System.Text;

using ProcessCall;

namespace AVRUPV1
{
	public class MainForm : System.Windows.Forms.Form
    {
        #region Initialization
        /* If you build AVRUP V1 from scratch using the Express edition
         * you will see some differences in the intializaion section. This is because
         * most of this code was written in earlier versions and imported into Express.
         * The code will work the same though.*/

        #region C# Express added definitions
        private System.Windows.Forms.GroupBox groupBoxSendText;
		private System.Windows.Forms.RichTextBox richTextBoxSend;
        private System.Windows.Forms.LinkLabel linkLabelVisitWebSite;
        private System.Windows.Forms.RichTextBox richTextBoxReceive;
        private System.Windows.Forms.GroupBox groupBoxReceive;
		private System.Windows.Forms.Label labelReceive;
        private System.Windows.Forms.Label labelSend;
        private MenuStrip menuStrip1;
        private ToolStripMenuItem settingsToolStripMenuItem;
        private ToolStripMenuItem portToolStripMenuItem;
        private ToolStripMenuItem sendToolStripMenuItem;
        private ToolStripMenuItem receiveToolStripMenuItem;
        private ToolStripMenuItem helpToolStripMenuItem;
        private ContextMenuStrip contextMenuStripSend;
        private IContainer components;
        private ToolStripMenuItem copyToolStripMenuItem;
        private ToolStripMenuItem cutToolStripMenuItem;
        private ToolStripMenuItem pasteToolStripMenuItem;
        private ToolStripMenuItem selectAllToolStripMenuItem;
        private ToolStripMenuItem undoToolStripMenuItem;
        private ToolStripMenuItem redoToolStripMenuItem;
        private SerialPort serialPort1;
        private ToolStripMenuItem openPortToolStripMenuItem;
        private ToolStripMenuItem saveAsToolStripMenuItem;
        private SaveFileDialog saveFileDialog1;
        private ToolStripMenuItem loadFileToolStripMenuItem;
        private OpenFileDialog openFileDialog1;
        private ToolStripSeparator toolStripSeparator1;
        private ToolStripSeparator toolStripSeparator2;
        private ToolStripMenuItem deleteToolStripMenuItem;
        private Panel panel1;
        #endregion

        #region Startup definitions

        // Version string for Help About form
        private string VersionDate = "Version Beta 1 - March 26, 2010";

        // There are two modes: 
        // 1. AVR Uploader that sends a script to avrdude
        // 2. Serial Monitor that sends/receives text
        private bool upload = true; // when false the mode is Serial Monitor

        private string avrdudeFilePath = "PATH NOT SET";
        private string boardXMLFilename = "NOT SET";

        // Create an instance of the settings form
        PortSettings portSettings = new PortSettings();

        // String for AVRDude script
        private string AVRDudeOut = "avrdude ";

		// Immediate or Queued state for sending data
		//private bool SendImmediate = true;
		//private string QueuedString = "";

		// Send with terminal characters
        //private bool UseTermChar = false;

		// Receive as ASCII or Hex state
		private bool ReceiveASCII = true;

        // Substitute LF for CR+LF
        private bool SubstituteLF = true;

		// Create an instance of the TerminalData class
		XMLData xMLData = new XMLData();
	
		// Create an instance of the TerminalXMLIO class to read the terminal data
		XMLIO dataXMLIO = new XMLIO();
		
		// Create MacroData arrays
		//string[] MacroDataText = new string[52];
		//string[] MacroDataData = new string[52];
        //string[] MacroDataType = new string[52];		
		
        // Boolean for the port open state
        public bool PortOpen = false;
        private Timer timerSendByte;
        private ToolStripMenuItem fileToolStripMenuItem;
        private ToolStripMenuItem openInSendBoxToolStripMenuItem;
        private ToolStripMenuItem saveSendBoxToolStripMenuItem;
        private ToolStripMenuItem saveReceiveBoxToolStripMenuItem;
        private ToolStripMenuItem manualToolStripMenuItem;
        private ToolStripMenuItem smileyMicrosToolStripMenuItem;
        private ToolStripMenuItem copyToolStripMenuItem1;
        private ToolStripMenuItem cutToolStripMenuItem1;
        private ToolStripMenuItem deleteToolStripMenuItem1;
        private ToolStripMenuItem selectAllToolStripMenuItem1;
        private ToolStripSeparator toolStripSeparator4;
        private ToolStripMenuItem saveFileAsToolStripMenuItem;
        private ContextMenuStrip contextMenuStripReceive;
        private ToolStripMenuItem aboutToolStripMenuItem;
        private ToolStripMenuItem openXMLDataToolStripMenuItem;
        private ToolStripMenuItem substituteLFForCRLFToolStripMenuItem;
        private Button buttonReset;
        private Button buttonOkay;
        private Button buttonCancel;
        private ToolStripMenuItem boardsToolStripMenuItem;
        private OpenFileDialog openFileDialogBoards;
        private ToolStripMenuItem selectPortToolStripMenuItem;

        // Boolean for the Ring Indicator modem state
        public bool RingIndicator = false;

		#endregion
	
		#region Startup functions

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// Read the XML data from xmlData.xml
			//dataXMLIO.appPath = System.Environment.CurrentDirectory; 
            
			//xMLData = dataXMLIO.XMLRead();

		}
		
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}
		
		private void Form1_Load(object sender, System.EventArgs e)
		{
            richTextBoxSend.Text = "1. Click 'Select Board' menu item and open XML file.\n";
            richTextBoxSend.Text += "2. Click 'Select Port' menu item and select the COM port.\n";
            richTextBoxSend.Text += "3. Click 'File to Upload' menu item and browse to hex file.\n";

            //selectBoard();
            //showParams();
            /*uploadMode(); // start in upload mode

		   // Initialize the terminal with default settings

          if (xMLData.board == "arduino")
           {
               serialPort1.BaudRate = portSettings.selectedBaudrate = xMLData.ArduinoBaud;
           }
           //else if (xMLData.board == "butterfly")
           //{
           //    serialPort1.BaudRate = portSettings.selectedBaudrate = xMLData.ButterflyBaud;
           //}
           else
           {
               this.Text = "Form1 Load: Error in xMLData.board";
           } 

           serialPort1.PortName = portSettings.selectedPort = xMLData.COMPort;                     

           serialPort1.DataBits = portSettings.selectedDataBits = xMLData.Databits;
 
           string temp = xMLData.Parity;
           switch (temp)
           {
               case "Even":
                   serialPort1.Parity = portSettings.selectedParity = Parity.Even;
                   break;
               case "Mark":
                   serialPort1.Parity = portSettings.selectedParity = Parity.Mark;
                   break;
               case "None":
                   serialPort1.Parity = portSettings.selectedParity = Parity.None;
                   break;
               case "Odd":
                   serialPort1.Parity = portSettings.selectedParity = Parity.Odd;
                   break;
               case "Space":
                   serialPort1.Parity = portSettings.selectedParity = Parity.Space;
                   break;
               default:
                   serialPort1.Parity = portSettings.selectedParity = Parity.None;
                   break;
           }

           temp = xMLData.Stopbits;
           switch (temp)
           {
               case "None":
                   serialPort1.StopBits = portSettings.selectedStopBits = StopBits.None;
                   break;
               case "1":
                   serialPort1.StopBits = portSettings.selectedStopBits = StopBits.One;
                   break;
               //case "1.5": // not supported by FT232R
               //serialPort1.StopBits = = StopBits.OnePointFive;
               //break;
               case "2":
                   serialPort1.StopBits = portSettings.selectedStopBits = StopBits.Two;
                   break;
               default:
                   serialPort1.StopBits = portSettings.selectedStopBits = StopBits.One;
                   break;
           }

           temp = xMLData.Handshake;
           switch (temp)
           {
               case "None":
                   serialPort1.Handshake = portSettings.selectedHandshaking = Handshake.None;
                   break;
               case "RTS/CTS":
                   serialPort1.Handshake = portSettings.selectedHandshaking = Handshake.RequestToSend;
                   break;
               case "Xon/Xoff":
                   serialPort1.Handshake = portSettings.selectedHandshaking = Handshake.XOnXOff;
                   break;
               default:
                   serialPort1.Handshake = portSettings.selectedHandshaking = Handshake.None;
                   break;
           }*/	
		}
		#endregion

        #region Windows Form Designer generated code
        /// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.labelSend = new System.Windows.Forms.Label();
            this.labelReceive = new System.Windows.Forms.Label();
            this.groupBoxReceive = new System.Windows.Forms.GroupBox();
            this.richTextBoxReceive = new System.Windows.Forms.RichTextBox();
            this.linkLabelVisitWebSite = new System.Windows.Forms.LinkLabel();
            this.richTextBoxSend = new System.Windows.Forms.RichTextBox();
            this.groupBoxSendText = new System.Windows.Forms.GroupBox();
            this.buttonOkay = new System.Windows.Forms.Button();
            this.buttonCancel = new System.Windows.Forms.Button();
            this.menuStrip1 = new System.Windows.Forms.MenuStrip();
            this.fileToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.openInSendBoxToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.saveSendBoxToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.saveReceiveBoxToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.openXMLDataToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.selectPortToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.boardsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.settingsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.portToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.sendToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.receiveToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.substituteLFForCRLFToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.openPortToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.helpToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.manualToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.aboutToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.smileyMicrosToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.contextMenuStripSend = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.undoToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.redoToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.toolStripSeparator1 = new System.Windows.Forms.ToolStripSeparator();
            this.cutToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.copyToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.pasteToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.deleteToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.selectAllToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.toolStripSeparator2 = new System.Windows.Forms.ToolStripSeparator();
            this.loadFileToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.saveAsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.serialPort1 = new System.IO.Ports.SerialPort(this.components);
            this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.panel1 = new System.Windows.Forms.Panel();
            this.timerSendByte = new System.Windows.Forms.Timer(this.components);
            this.copyToolStripMenuItem1 = new System.Windows.Forms.ToolStripMenuItem();
            this.cutToolStripMenuItem1 = new System.Windows.Forms.ToolStripMenuItem();
            this.deleteToolStripMenuItem1 = new System.Windows.Forms.ToolStripMenuItem();
            this.selectAllToolStripMenuItem1 = new System.Windows.Forms.ToolStripMenuItem();
            this.toolStripSeparator4 = new System.Windows.Forms.ToolStripSeparator();
            this.saveFileAsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.contextMenuStripReceive = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.buttonReset = new System.Windows.Forms.Button();
            this.openFileDialogBoards = new System.Windows.Forms.OpenFileDialog();
            this.groupBoxReceive.SuspendLayout();
            this.groupBoxSendText.SuspendLayout();
            this.menuStrip1.SuspendLayout();
            this.contextMenuStripSend.SuspendLayout();
            this.contextMenuStripReceive.SuspendLayout();
            this.SuspendLayout();
            // 
            // labelSend
            // 
            this.labelSend.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.labelSend.Location = new System.Drawing.Point(4, 10);
            this.labelSend.Name = "labelSend";
            this.labelSend.Size = new System.Drawing.Size(120, 16);
            this.labelSend.TabIndex = 100;
            this.labelSend.Text = "AVRDUDE Script:";
            // 
            // labelReceive
            // 
            this.labelReceive.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.labelReceive.Location = new System.Drawing.Point(4, 10);
            this.labelReceive.Name = "labelReceive";
            this.labelReceive.Size = new System.Drawing.Size(146, 16);
            this.labelReceive.TabIndex = 101;
            this.labelReceive.Text = "AVRDUDE Response:";
            // 
            // groupBoxReceive
            // 
            this.groupBoxReceive.BackColor = System.Drawing.Color.Transparent;
            this.groupBoxReceive.Controls.Add(this.labelReceive);
            this.groupBoxReceive.Controls.Add(this.richTextBoxReceive);
            this.groupBoxReceive.Location = new System.Drawing.Point(7, 189);
            this.groupBoxReceive.Name = "groupBoxReceive";
            this.groupBoxReceive.Size = new System.Drawing.Size(546, 132);
            this.groupBoxReceive.TabIndex = 87;
            this.groupBoxReceive.TabStop = false;
            // 
            // richTextBoxReceive
            // 
            this.richTextBoxReceive.EnableAutoDragDrop = true;
            this.richTextBoxReceive.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.richTextBoxReceive.Location = new System.Drawing.Point(4, 26);
            this.richTextBoxReceive.Name = "richTextBoxReceive";
            this.richTextBoxReceive.Size = new System.Drawing.Size(536, 100);
            this.richTextBoxReceive.TabIndex = 5;
            this.richTextBoxReceive.Text = "";
            this.richTextBoxReceive.MouseDown += new System.Windows.Forms.MouseEventHandler(this.richTextBoxReceive_MouseDown);
            this.richTextBoxReceive.TextChanged += new System.EventHandler(this.richTextBoxReceive_TextChanged);
            // 
            // linkLabelVisitWebSite
            // 
            this.linkLabelVisitWebSite.BackColor = System.Drawing.Color.SkyBlue;
            this.linkLabelVisitWebSite.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.linkLabelVisitWebSite.Location = new System.Drawing.Point(424, 5);
            this.linkLabelVisitWebSite.Name = "linkLabelVisitWebSite";
            this.linkLabelVisitWebSite.Size = new System.Drawing.Size(130, 19);
            this.linkLabelVisitWebSite.TabIndex = 3;
            this.linkLabelVisitWebSite.TabStop = true;
            this.linkLabelVisitWebSite.Text = "www.SmileyMicros.com";
            this.linkLabelVisitWebSite.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelVisitWebSite_LinkClicked);
            // 
            // richTextBoxSend
            // 
            this.richTextBoxSend.EnableAutoDragDrop = true;
            this.richTextBoxSend.Location = new System.Drawing.Point(5, 26);
            this.richTextBoxSend.Name = "richTextBoxSend";
            this.richTextBoxSend.Size = new System.Drawing.Size(535, 101);
            this.richTextBoxSend.TabIndex = 0;
            this.richTextBoxSend.Text = "";
            this.richTextBoxSend.MouseDown += new System.Windows.Forms.MouseEventHandler(this.richTextBoxSend_MouseDown);
            this.richTextBoxSend.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.richTextBoxSend_KeyPress);
            // 
            // groupBoxSendText
            // 
            this.groupBoxSendText.BackColor = System.Drawing.Color.Transparent;
            this.groupBoxSendText.Controls.Add(this.richTextBoxSend);
            this.groupBoxSendText.Controls.Add(this.buttonOkay);
            this.groupBoxSendText.Controls.Add(this.buttonCancel);
            this.groupBoxSendText.Controls.Add(this.labelSend);
            this.groupBoxSendText.Location = new System.Drawing.Point(7, 21);
            this.groupBoxSendText.Name = "groupBoxSendText";
            this.groupBoxSendText.Size = new System.Drawing.Size(546, 162);
            this.groupBoxSendText.TabIndex = 86;
            this.groupBoxSendText.TabStop = false;
            // 
            // buttonOkay
            // 
            this.buttonOkay.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.buttonOkay.Location = new System.Drawing.Point(105, 133);
            this.buttonOkay.Name = "buttonOkay";
            this.buttonOkay.Size = new System.Drawing.Size(129, 23);
            this.buttonOkay.TabIndex = 114;
            this.buttonOkay.Text = "Upload to board";
            this.buttonOkay.UseVisualStyleBackColor = true;
            this.buttonOkay.Click += new System.EventHandler(this.buttonOkay_Click);
            // 
            // buttonCancel
            // 
            this.buttonCancel.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.buttonCancel.Location = new System.Drawing.Point(328, 133);
            this.buttonCancel.Name = "buttonCancel";
            this.buttonCancel.Size = new System.Drawing.Size(75, 23);
            this.buttonCancel.TabIndex = 115;
            this.buttonCancel.Text = "Cancel";
            this.buttonCancel.UseVisualStyleBackColor = true;
            this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
            // 
            // menuStrip1
            // 
            this.menuStrip1.BackColor = System.Drawing.Color.LightSkyBlue;
            this.menuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.boardsToolStripMenuItem,
            this.selectPortToolStripMenuItem,
            this.fileToolStripMenuItem,
            this.settingsToolStripMenuItem,
            this.openPortToolStripMenuItem,
            this.helpToolStripMenuItem});
            this.menuStrip1.Location = new System.Drawing.Point(0, 0);
            this.menuStrip1.Name = "menuStrip1";
            this.menuStrip1.Size = new System.Drawing.Size(556, 24);
            this.menuStrip1.TabIndex = 100;
            this.menuStrip1.Text = "menuStrip1";
            // 
            // fileToolStripMenuItem
            // 
            this.fileToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.openInSendBoxToolStripMenuItem,
            this.saveSendBoxToolStripMenuItem,
            this.saveReceiveBoxToolStripMenuItem,
            this.openXMLDataToolStripMenuItem});
            this.fileToolStripMenuItem.Name = "fileToolStripMenuItem";
            this.fileToolStripMenuItem.Size = new System.Drawing.Size(91, 20);
            this.fileToolStripMenuItem.Text = "File to upload";
            this.fileToolStripMenuItem.Click += new System.EventHandler(this.fileToolStripMenuItem_Click);
            // 
            // openInSendBoxToolStripMenuItem
            // 
            this.openInSendBoxToolStripMenuItem.Enabled = false;
            this.openInSendBoxToolStripMenuItem.Name = "openInSendBoxToolStripMenuItem";
            this.openInSendBoxToolStripMenuItem.Size = new System.Drawing.Size(167, 22);
            this.openInSendBoxToolStripMenuItem.Text = "Open in Send Box";
            this.openInSendBoxToolStripMenuItem.Visible = false;
            this.openInSendBoxToolStripMenuItem.Click += new System.EventHandler(this.openInSendBoxToolStripMenuItem_Click_1);
            // 
            // saveSendBoxToolStripMenuItem
            // 
            this.saveSendBoxToolStripMenuItem.Enabled = false;
            this.saveSendBoxToolStripMenuItem.Name = "saveSendBoxToolStripMenuItem";
            this.saveSendBoxToolStripMenuItem.Size = new System.Drawing.Size(167, 22);
            this.saveSendBoxToolStripMenuItem.Text = "Save Send Box";
            this.saveSendBoxToolStripMenuItem.Visible = false;
            this.saveSendBoxToolStripMenuItem.Click += new System.EventHandler(this.saveSendBoxToolStripMenuItem_Click_1);
            // 
            // saveReceiveBoxToolStripMenuItem
            // 
            this.saveReceiveBoxToolStripMenuItem.Enabled = false;
            this.saveReceiveBoxToolStripMenuItem.Name = "saveReceiveBoxToolStripMenuItem";
            this.saveReceiveBoxToolStripMenuItem.Size = new System.Drawing.Size(167, 22);
            this.saveReceiveBoxToolStripMenuItem.Text = "Save Receive Box";
            this.saveReceiveBoxToolStripMenuItem.Visible = false;
            this.saveReceiveBoxToolStripMenuItem.Click += new System.EventHandler(this.saveReceiveBoxToolStripMenuItem_Click_1);
            // 
            // openXMLDataToolStripMenuItem
            // 
            this.openXMLDataToolStripMenuItem.Enabled = false;
            this.openXMLDataToolStripMenuItem.Name = "openXMLDataToolStripMenuItem";
            this.openXMLDataToolStripMenuItem.Size = new System.Drawing.Size(167, 22);
            this.openXMLDataToolStripMenuItem.Text = "Open XML Data";
            this.openXMLDataToolStripMenuItem.Visible = false;
            // 
            // selectPortToolStripMenuItem
            // 
            this.selectPortToolStripMenuItem.Name = "selectPortToolStripMenuItem";
            this.selectPortToolStripMenuItem.Size = new System.Drawing.Size(75, 20);
            this.selectPortToolStripMenuItem.Text = "Select Port";
            this.selectPortToolStripMenuItem.Click += new System.EventHandler(this.selectPortToolStripMenuItem_Click);
            // 
            // boardsToolStripMenuItem
            // 
            this.boardsToolStripMenuItem.Name = "boardsToolStripMenuItem";
            this.boardsToolStripMenuItem.Size = new System.Drawing.Size(84, 20);
            this.boardsToolStripMenuItem.Text = "Select Board";
            this.boardsToolStripMenuItem.Click += new System.EventHandler(this.boardsToolStripMenuItem_Click);
            // 
            // settingsToolStripMenuItem
            // 
            this.settingsToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.portToolStripMenuItem,
            this.sendToolStripMenuItem,
            this.receiveToolStripMenuItem,
            this.substituteLFForCRLFToolStripMenuItem});
            this.settingsToolStripMenuItem.Name = "settingsToolStripMenuItem";
            this.settingsToolStripMenuItem.Size = new System.Drawing.Size(61, 20);
            this.settingsToolStripMenuItem.Text = "Settings";
            this.settingsToolStripMenuItem.Visible = false;
            // 
            // portToolStripMenuItem
            // 
            this.portToolStripMenuItem.Name = "portToolStripMenuItem";
            this.portToolStripMenuItem.Size = new System.Drawing.Size(236, 22);
            this.portToolStripMenuItem.Text = "Port";
            this.portToolStripMenuItem.Click += new System.EventHandler(this.portToolStripMenuItem_Click);
            // 
            // sendToolStripMenuItem
            // 
            this.sendToolStripMenuItem.Name = "sendToolStripMenuItem";
            this.sendToolStripMenuItem.Size = new System.Drawing.Size(236, 22);
            this.sendToolStripMenuItem.Text = "Send textBox Properties";
            this.sendToolStripMenuItem.Click += new System.EventHandler(this.sendToolStripMenuItem_Click);
            // 
            // receiveToolStripMenuItem
            // 
            this.receiveToolStripMenuItem.Name = "receiveToolStripMenuItem";
            this.receiveToolStripMenuItem.Size = new System.Drawing.Size(236, 22);
            this.receiveToolStripMenuItem.Text = "Receive textBox Properties";
            this.receiveToolStripMenuItem.Click += new System.EventHandler(this.receiveToolStripMenuItem_Click);
            // 
            // substituteLFForCRLFToolStripMenuItem
            // 
            this.substituteLFForCRLFToolStripMenuItem.Name = "substituteLFForCRLFToolStripMenuItem";
            this.substituteLFForCRLFToolStripMenuItem.Size = new System.Drawing.Size(236, 22);
            this.substituteLFForCRLFToolStripMenuItem.Text = "Do not substitute LF for CR+LF";
            this.substituteLFForCRLFToolStripMenuItem.Click += new System.EventHandler(this.substituteLFForCRLFToolStripMenuItem_Click);
            // 
            // openPortToolStripMenuItem
            // 
            this.openPortToolStripMenuItem.Name = "openPortToolStripMenuItem";
            this.openPortToolStripMenuItem.Size = new System.Drawing.Size(73, 20);
            this.openPortToolStripMenuItem.Text = "Open Port";
            this.openPortToolStripMenuItem.Visible = false;
            this.openPortToolStripMenuItem.Click += new System.EventHandler(this.openPortToolStripMenuItem_Click);
            // 
            // helpToolStripMenuItem
            // 
            this.helpToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.manualToolStripMenuItem,
            this.aboutToolStripMenuItem,
            this.smileyMicrosToolStripMenuItem});
            this.helpToolStripMenuItem.Name = "helpToolStripMenuItem";
            this.helpToolStripMenuItem.Size = new System.Drawing.Size(44, 20);
            this.helpToolStripMenuItem.Text = "Help";
            // 
            // manualToolStripMenuItem
            // 
            this.manualToolStripMenuItem.Name = "manualToolStripMenuItem";
            this.manualToolStripMenuItem.Size = new System.Drawing.Size(152, 22);
            this.manualToolStripMenuItem.Text = "Manual";
            this.manualToolStripMenuItem.Click += new System.EventHandler(this.manualToolStripMenuItem_Click);
            // 
            // aboutToolStripMenuItem
            // 
            this.aboutToolStripMenuItem.Name = "aboutToolStripMenuItem";
            this.aboutToolStripMenuItem.Size = new System.Drawing.Size(148, 22);
            this.aboutToolStripMenuItem.Text = "About";
            this.aboutToolStripMenuItem.Click += new System.EventHandler(this.aboutToolStripMenuItem_Click);
            // 
            // smileyMicrosToolStripMenuItem
            // 
            this.smileyMicrosToolStripMenuItem.Name = "smileyMicrosToolStripMenuItem";
            this.smileyMicrosToolStripMenuItem.Size = new System.Drawing.Size(148, 22);
            this.smileyMicrosToolStripMenuItem.Text = "Smiley Micros";
            this.smileyMicrosToolStripMenuItem.Click += new System.EventHandler(this.smileyMicrosToolStripMenuItem_Click);
            // 
            // contextMenuStripSend
            // 
            this.contextMenuStripSend.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.undoToolStripMenuItem,
            this.redoToolStripMenuItem,
            this.toolStripSeparator1,
            this.cutToolStripMenuItem,
            this.copyToolStripMenuItem,
            this.pasteToolStripMenuItem,
            this.deleteToolStripMenuItem,
            this.selectAllToolStripMenuItem,
            this.toolStripSeparator2,
            this.loadFileToolStripMenuItem,
            this.saveAsToolStripMenuItem});
            this.contextMenuStripSend.Name = "contextMenuStripSend";
            this.contextMenuStripSend.Size = new System.Drawing.Size(136, 214);
            // 
            // undoToolStripMenuItem
            // 
            this.undoToolStripMenuItem.Name = "undoToolStripMenuItem";
            this.undoToolStripMenuItem.Size = new System.Drawing.Size(135, 22);
            this.undoToolStripMenuItem.Text = "Undo";
            this.undoToolStripMenuItem.Click += new System.EventHandler(this.undoToolStripMenuItem_Click);
            // 
            // redoToolStripMenuItem
            // 
            this.redoToolStripMenuItem.Name = "redoToolStripMenuItem";
            this.redoToolStripMenuItem.Size = new System.Drawing.Size(135, 22);
            this.redoToolStripMenuItem.Text = "Redo";
            this.redoToolStripMenuItem.Click += new System.EventHandler(this.redoToolStripMenuItem_Click);
            // 
            // toolStripSeparator1
            // 
            this.toolStripSeparator1.Name = "toolStripSeparator1";
            this.toolStripSeparator1.Size = new System.Drawing.Size(132, 6);
            // 
            // cutToolStripMenuItem
            // 
            this.cutToolStripMenuItem.Name = "cutToolStripMenuItem";
            this.cutToolStripMenuItem.Size = new System.Drawing.Size(135, 22);
            this.cutToolStripMenuItem.Text = "Cut";
            this.cutToolStripMenuItem.Click += new System.EventHandler(this.cutToolStripMenuItem_Click);
            // 
            // copyToolStripMenuItem
            // 
            this.copyToolStripMenuItem.Name = "copyToolStripMenuItem";
            this.copyToolStripMenuItem.Size = new System.Drawing.Size(135, 22);
            this.copyToolStripMenuItem.Text = "Copy";
            this.copyToolStripMenuItem.Click += new System.EventHandler(this.copyToolStripMenuItem_Click);
            // 
            // pasteToolStripMenuItem
            // 
            this.pasteToolStripMenuItem.Name = "pasteToolStripMenuItem";
            this.pasteToolStripMenuItem.Size = new System.Drawing.Size(135, 22);
            this.pasteToolStripMenuItem.Text = "Paste";
            this.pasteToolStripMenuItem.Click += new System.EventHandler(this.pasteToolStripMenuItem_Click);
            // 
            // deleteToolStripMenuItem
            // 
            this.deleteToolStripMenuItem.Name = "deleteToolStripMenuItem";
            this.deleteToolStripMenuItem.Size = new System.Drawing.Size(135, 22);
            this.deleteToolStripMenuItem.Text = "Clear";
            this.deleteToolStripMenuItem.Click += new System.EventHandler(this.deleteToolStripMenuItem_Click);
            // 
            // selectAllToolStripMenuItem
            // 
            this.selectAllToolStripMenuItem.Name = "selectAllToolStripMenuItem";
            this.selectAllToolStripMenuItem.Size = new System.Drawing.Size(135, 22);
            this.selectAllToolStripMenuItem.Text = "Select All";
            this.selectAllToolStripMenuItem.Click += new System.EventHandler(this.selectAllToolStripMenuItem_Click);
            // 
            // toolStripSeparator2
            // 
            this.toolStripSeparator2.Name = "toolStripSeparator2";
            this.toolStripSeparator2.Size = new System.Drawing.Size(132, 6);
            // 
            // loadFileToolStripMenuItem
            // 
            this.loadFileToolStripMenuItem.Name = "loadFileToolStripMenuItem";
            this.loadFileToolStripMenuItem.Size = new System.Drawing.Size(135, 22);
            this.loadFileToolStripMenuItem.Text = "Load File";
            this.loadFileToolStripMenuItem.Click += new System.EventHandler(this.loadFileToolStripMenuItem_Click);
            // 
            // saveAsToolStripMenuItem
            // 
            this.saveAsToolStripMenuItem.Name = "saveAsToolStripMenuItem";
            this.saveAsToolStripMenuItem.Size = new System.Drawing.Size(135, 22);
            this.saveAsToolStripMenuItem.Text = "Save File As";
            this.saveAsToolStripMenuItem.Click += new System.EventHandler(this.saveAsToolStripMenuItem_Click);
            // 
            // serialPort1
            // 
            this.serialPort1.RtsEnable = true;
            this.serialPort1.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(this.serialPort1_DataReceived);
            // 
            // openFileDialog1
            // 
            this.openFileDialog1.FileName = "openFileDialog1";
            // 
            // panel1
            // 
            this.panel1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("panel1.BackgroundImage")));
            this.panel1.Location = new System.Drawing.Point(305, 329);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(200, 40);
            this.panel1.TabIndex = 111;
            this.panel1.MouseLeave += new System.EventHandler(this.panel1_MouseLeave);
            this.panel1.MouseClick += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseClick);
            this.panel1.MouseEnter += new System.EventHandler(this.panel1_MouseEnter);
            // 
            // copyToolStripMenuItem1
            // 
            this.copyToolStripMenuItem1.Name = "copyToolStripMenuItem1";
            this.copyToolStripMenuItem1.Size = new System.Drawing.Size(135, 22);
            this.copyToolStripMenuItem1.Text = "Copy";
            this.copyToolStripMenuItem1.Click += new System.EventHandler(this.copyToolStripMenuItem1_Click);
            // 
            // cutToolStripMenuItem1
            // 
            this.cutToolStripMenuItem1.Name = "cutToolStripMenuItem1";
            this.cutToolStripMenuItem1.Size = new System.Drawing.Size(135, 22);
            this.cutToolStripMenuItem1.Text = "Cut";
            this.cutToolStripMenuItem1.Click += new System.EventHandler(this.cutToolStripMenuItem1_Click);
            // 
            // deleteToolStripMenuItem1
            // 
            this.deleteToolStripMenuItem1.Name = "deleteToolStripMenuItem1";
            this.deleteToolStripMenuItem1.Size = new System.Drawing.Size(135, 22);
            this.deleteToolStripMenuItem1.Text = "Clear";
            this.deleteToolStripMenuItem1.Click += new System.EventHandler(this.deleteToolStripMenuItem1_Click);
            // 
            // selectAllToolStripMenuItem1
            // 
            this.selectAllToolStripMenuItem1.Name = "selectAllToolStripMenuItem1";
            this.selectAllToolStripMenuItem1.Size = new System.Drawing.Size(135, 22);
            this.selectAllToolStripMenuItem1.Text = "Select All";
            this.selectAllToolStripMenuItem1.Click += new System.EventHandler(this.selectAllToolStripMenuItem1_Click);
            // 
            // toolStripSeparator4
            // 
            this.toolStripSeparator4.Name = "toolStripSeparator4";
            this.toolStripSeparator4.Size = new System.Drawing.Size(132, 6);
            // 
            // saveFileAsToolStripMenuItem
            // 
            this.saveFileAsToolStripMenuItem.Name = "saveFileAsToolStripMenuItem";
            this.saveFileAsToolStripMenuItem.Size = new System.Drawing.Size(135, 22);
            this.saveFileAsToolStripMenuItem.Text = "Save File As";
            this.saveFileAsToolStripMenuItem.Click += new System.EventHandler(this.saveFileAsToolStripMenuItem_Click);
            // 
            // contextMenuStripReceive
            // 
            this.contextMenuStripReceive.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.copyToolStripMenuItem1,
            this.cutToolStripMenuItem1,
            this.deleteToolStripMenuItem1,
            this.selectAllToolStripMenuItem1,
            this.toolStripSeparator4,
            this.saveFileAsToolStripMenuItem});
            this.contextMenuStripReceive.Name = "contextMenuStripReceive";
            this.contextMenuStripReceive.Size = new System.Drawing.Size(136, 120);
            // 
            // buttonReset
            // 
            this.buttonReset.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.buttonReset.Location = new System.Drawing.Point(54, 335);
            this.buttonReset.Name = "buttonReset";
            this.buttonReset.Size = new System.Drawing.Size(159, 26);
            this.buttonReset.TabIndex = 112;
            this.buttonReset.Text = "Toggle DTR and RTS";
            this.buttonReset.UseVisualStyleBackColor = true;
            this.buttonReset.Visible = false;
            this.buttonReset.Click += new System.EventHandler(this.buttonReset_Click);
            // 
            // openFileDialogBoards
            // 
            this.openFileDialogBoards.FileName = "openFileDialogBoards";
            // 
            // MainForm
            // 
            this.AllowDrop = true;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.Color.LightBlue;
            this.ClientSize = new System.Drawing.Size(556, 372);
            this.Controls.Add(this.linkLabelVisitWebSite);
            this.Controls.Add(this.menuStrip1);
            this.Controls.Add(this.groupBoxSendText);
            this.Controls.Add(this.groupBoxReceive);
            this.Controls.Add(this.panel1);
            this.Controls.Add(this.buttonReset);
            this.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MainMenuStrip = this.menuStrip1;
            this.MaximizeBox = false;
            this.Name = "MainForm";
            this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "AVRUP V1";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.groupBoxReceive.ResumeLayout(false);
            this.groupBoxSendText.ResumeLayout(false);
            this.menuStrip1.ResumeLayout(false);
            this.menuStrip1.PerformLayout();
            this.contextMenuStripSend.ResumeLayout(false);
            this.contextMenuStripReceive.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

        #endregion

        #region GUI

        #region Open REALLY GREAT website

        // And this is not shameless commercialism. I have NO shame.
        // And2 - now you know how to do it.
		private void linkLabelVisitWebSite_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start("www.smileymicros.com");		
		}

        // Open website 
        private void panel1_MouseClick(object sender, MouseEventArgs e)
        {
            System.Diagnostics.Process.Start("www.smileymicros.com");
        }

        // Show hand cursor and change color to intice click to website
        private void panel1_MouseEnter(object sender, EventArgs e)
        {
            panel1.Cursor = Cursors.Hand;
            panel1.BackColor = Color.SkyBlue;
        }

        // Cursor reverts on leaving, but color doesn't so revert it
        private void panel1_MouseLeave(object sender, EventArgs e)
        {
            panel1.BackColor = Color.LightBlue;
        }

        #endregion
        
        #region Buttons   
        private void buttonClear_Click(object sender, System.EventArgs e)
		{
			richTextBoxReceive.Text = "";
            //textBoxSendCount.Text = "";
		}

        private void buttonClearSend_Click(object sender, EventArgs e)
        {
            richTextBoxSend.Text = "";
        }
		
		private void buttonSettings_Click(object sender, System.EventArgs e)
		{
            PortSettings portSettings = new PortSettings();

            portSettings.ShowDialog();
            if (portSettings.DialogResult == DialogResult.OK)
            {
                serialPort1.PortName = portSettings.selectedPort;
                serialPort1.BaudRate = portSettings.selectedBaudrate;
            }
		}
		
		private void buttonOpenClosePort_Click(object sender, System.EventArgs e)
		{
			if(PortOpen)
			{
				PortOpen = false;
                serialPort1.Close();
                //this.Text = "AVRUP V1 - Port is closed";
			}
			else
			{
				PortOpen = true;
 
                try
                {
                    serialPort1.Open();
                 }
                catch(System.Exception ex)
                {
                    MessageBox.Show("Error - buttonOpenClosePort_ClickSystem.Exception: " + ex);
                }
				showSettings();		
			}
		}
		
		private void buttonHelp_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("HELP! is coming soon to a computer near you...");
		}
	
		#endregion
		
        #region Help

        private void manualToolStripMenuItem_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("AVRUP V1.pdf");
        }

        private void smileyMicrosToolStripMenuItem_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("www.smileymicros.com");
        }

        // JWP 2/17/08 
        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            About about = new About();
            about.versionDate = VersionDate;
            about.Show(); 
        }

        #endregion    

        #endregion

        #region ProcessCaller

        private ProcessCaller processCaller;

        private void buttonOkay_Click(object sender, EventArgs e)
        {
            if (upload)
            {
                this.Cursor = Cursors.AppStarting;
                this.buttonOkay.Enabled = false;

                processCaller = new ProcessCaller(this);
                //processCaller.FileName = @"..\..\hello.bat";
                //processCaller.FileName = @"..\..\SmallConsoleProgram.exe";
                processCaller.FileName = @"avrdude.exe";
                processCaller.Arguments = AVRDudeOut;// richTextBoxSend.Text;//"";
                processCaller.StdErrReceived += new DataReceivedHandler(writeStreamInfo);
                processCaller.StdOutReceived += new DataReceivedHandler(writeStreamInfo);
                processCaller.Completed += new EventHandler(processCompletedOrCanceled);
                processCaller.Cancelled += new EventHandler(processCompletedOrCanceled);
                // processCaller.Failed += no event handler for this one, yet.

                this.richTextBoxReceive.Text = "Started function.  Please stand by.." + Environment.NewLine;

                // Toggle the DTR and RTS lines (one or the other will reset the board)
                // immediately before starting the process. 
                openPort();
                sendReset();
                openPort();


                // The following function starts a process and returns immediately,
                // thus allowing the form to stay responsive.
                processCaller.Start();
            }
            else // serial monitor send mode
            {
                //MessageBox.Show("You want me to send:\n" + richTextBoxSend.Text + "\n?");
                if (serialPort1.IsOpen)
                {
                    // TODO: this is not what you want todo, you want to open
                    // the avrdude as a process and sent the string as a command line script
                    SendASCIIString(richTextBoxSend.Text);
                }
                else MessageBox.Show("The serial port is not open.");
            }
        }

        // 11/3 Is this necessary?
        private void buttonCancel_Click(object sender, EventArgs e)
        {
            if (processCaller != null)
            {
                processCaller.Cancel();
            }
        }

        /// <summary>
        /// Handles the events of StdErrReceived and StdOutReceived.
        /// </summary>
        /// <remarks>
        /// If stderr were handled in a separate function, it could possibly
        /// be displayed in red in the richText box, but that is beyond 
        /// the scope of this demo.
        /// </remarks>
        private void writeStreamInfo(object sender, DataReceivedEventArgs e)
        {
            this.richTextBoxReceive.AppendText(e.Text + Environment.NewLine);
        }

        /// <summary>
        /// Handles the events of processCompleted & processCanceled
        /// </summary>
        private void processCompletedOrCanceled(object sender, EventArgs e)
        {
            this.Cursor = Cursors.Default;
            this.buttonOkay.Enabled = true;
        }

        #endregion


        #region Receive functions

        // we want to have the serial port thread report back data received, but to display
        // that data we must create a delegate function to show the data in the richTextBox

        string InputData = String.Empty;
        delegate void SetTextCallback(string text);

        // note that this function runs in a separate thread and thus we must use a delegate in order
        // to display the results in the richTextBox.
        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            if (ReceiveASCII)
            {
                serialPort1.Encoding = System.Text.Encoding.ASCII;
            }
            else
            {
                serialPort1.Encoding = System.Text.Encoding.Unicode;
            }

            InputData = serialPort1.ReadExisting();
            if (InputData != String.Empty)
            {
                SetText(InputData);
            }
        }
        
        private void SetText(string text)
        {
            if (richTextBoxReceive.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(SetText);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                if (ReceiveASCII) // Show in ASCII
                {
                    // You'd think the following line would work, but
                    // you get intermittent extra blank lines with CR+LF
                    //this.richTextBoxReceive.Text += text;

                    // Catch CR+LF and substitute a single LF
                    // Hack by ignoring all CR in ReceiveASCII mode
                    if (SubstituteLF)// But only if set to do so
                    {
                        foreach (char c in text)
                        {
                            if(c!='\r')this.richTextBoxReceive.Text += c;
                        }
                    }
                    else
                    {
                        this.richTextBoxReceive.Text += text;
                    }
                }
                else // Show in HEX
                {
                    Encoding unicode = Encoding.Unicode;

                    // Convert the string into a byte[].
                    byte[] unicodeBytes = unicode.GetBytes(text);

                    foreach (byte b in unicodeBytes)
                    {
                        if (b > 15)
                        {
                            richTextBoxReceive.Text += "0x" + b.ToString("X") + ",";
                        }
                        else richTextBoxReceive.Text += "0x0" + b.ToString("X") + ",";
                    }
                }
                //ReceiveCount += text.Length;
                //textBoxReceiveCount.Text = ReceiveCount.ToString();
            }          
        }

        private void substituteLFForCRLFToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (SubstituteLF == false)
            {
                SubstituteLF = true;
                this.substituteLFForCRLFToolStripMenuItem.Text = "Do not substitute LF for CR+LF"; 
            }
            else
            {
                SubstituteLF = false;
                this.substituteLFForCRLFToolStripMenuItem.Text = "Do substitute LF for CR+LF"; 
            }

        }

        // This rigaramole is needed to keep the last received item displayed
        // it kind of flickers and should be fixed
        private void richTextBoxReceive_TextChanged(object sender, System.EventArgs e)
        {
            moveCaretToEnd();
        }

        private void moveCaretToEnd()
        {
            richTextBoxReceive.SelectionStart = richTextBoxReceive.Text.Length;
            richTextBoxReceive.SelectionLength = 0;
            richTextBoxReceive.ScrollToCaret();
        }

       #endregion

		#region Send Text functions
        private void richTextBoxSend_KeyPress(object sender, KeyPressEventArgs e)
        {
/*			if(SendImmediate)
			{
                sendChar(e.KeyChar);
				//if(UseTermChar) sendTermChar();
			}
			else
			{
				QueuedString += e.KeyChar;
			}
*/		}

        private void sendChar(char c)
        {
            char[] data = new Char[1];
            data[0] = c;
            try
            {
                serialPort1.Write(data, 0, 1);
                //SendCount++;
                //textBoxSendCount.Text = SendCount.ToString();
            }
            catch
            {
                MessageBox.Show("Error: sendChar - failed to send.\nIs the port open?");
            }
        }

        // JWP 2/17/08 ammended changes of 4/28/07
        // JWP 4/28/07 - add sendByte function
        private bool sendByte(byte b)
        {
            byte[] data = new byte[1];
            data[0] = b;
            try
            {
                serialPort1.Write(data, 0, 1);
                //SendCount++;
                //textBoxSendCount.Text = SendCount.ToString();
            }
            catch
            {
                return false;
            }
            return true;
        }
        #endregion
        

        public void SendASCIIString(string str)
        {
            char[] c = str.ToCharArray();

            for (int i = 0; i < c.GetLength(0); i++)
            {
                sendChar(c[i]);
                // too fast for Butterfly??? 10/9/09
                //System.Threading.Thread.Sleep(100);
            }
        }
	

        #region Send Textbox Context menus 
        private void richTextBoxSend_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                contextMenuStripSend.Show(MousePosition);
            }   
        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxSend.Copy();
        }

        private void cutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxSend.Cut();
        }


        private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxSend.Clear();
            //textBoxSendCount.Text = "0";
            //SendCount = 0;
        }

        private void selectAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxSend.SelectAll();
        }

        private void undoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxSend.Undo();
        }

        private void redoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxSend.Redo();
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveSendBox();
        }

/*        private void pasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxSend.Paste();
            setToQueued();        
        }

        // use for paste and load
        private void setToQueued()
        {
            // set to send queued
            radioButtonQueued.Checked = true;
            SendImmediate = false;
            buttonSendQue.Enabled = true;
            QueuedString = richTextBoxSend.Text;
        }
*/
        // Context menu item
        private void loadFileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openInSendBox();
        }
        // File menu item
        private void openInSendBoxToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            openInSendBox();
        }

        private void saveSendBoxToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveSendBox();
        }

        private void saveSendBoxToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            saveSendBox();
        }

        private void openInSendBox()
        {
            string filename = "";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                filename = openFileDialog1.FileName;
                if (filename != "")
                {
                    richTextBoxSend.LoadFile(filename, RichTextBoxStreamType.PlainText);
                    //setToQueued();
                }
            }
            else
            {
                MessageBox.Show("Error loading file.");
            }
        }

        private void saveSendBox()
        {
            string filename = "";
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                filename = saveFileDialog1.FileName;
                if (filename != "") richTextBoxSend.SaveFile(filename, RichTextBoxStreamType.PlainText);
            }
        }

        // JWP 2/20/08 allow openning of different XML data files
/*        private void openXMLDataToolStripMenuItem_Click(object sender, EventArgs e)
        {
            xMLData = dataXMLIO.OpenXMLDataFile();
            listBoxMacros.Items.Clear();
            loadXMLData();
        }
*/
        #endregion

        #region Receive Textbox Context menus

        private void richTextBoxReceive_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                contextMenuStripReceive.Show(MousePosition);
            }
        }

        private void copyToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            richTextBoxReceive.Copy();
        }

        private void cutToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            richTextBoxReceive.Cut();
        }

        private void selectAllToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            richTextBoxReceive.SelectAll();
        }

        private void deleteToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            richTextBoxReceive.Clear();
        }

        private void saveFileAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveReceiveBox();
        }

        private void saveReceiveBoxToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveReceiveBox();
        }

        private void saveReceiveBoxToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            saveReceiveBox();
        }

        private void saveReceiveBox()
        {
            string filename = "";
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                filename = saveFileDialog1.FileName;
                if (filename != "") richTextBoxReceive.SaveFile(filename, RichTextBoxStreamType.PlainText);
            }
        }

        #endregion

        #region Send & Receive richTextBox settings
        private void sendToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TextBoxSettings send = new TextBoxSettings();

            if (send.ShowDialog() == DialogResult.OK)
            {
                richTextBoxSend.BackColor = send.backColor;
                richTextBoxSend.ForeColor = send.foreColor;
                if(send.font != null) richTextBoxSend.Font = send.font;
            }
            else
            {
                MessageBox.Show("Send richTextBox settings canceled.");
            }

        }

        private void receiveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TextBoxSettings receive = new TextBoxSettings();

            if (receive.ShowDialog() == DialogResult.OK)
            {
                richTextBoxReceive.BackColor = receive.backColor;
                richTextBoxReceive.ForeColor = receive.foreColor;
                if (receive.font != null) richTextBoxReceive.Font = receive.font;
            }
            else
            {
                MessageBox.Show("Receive richTextBox settings canceled.");
            }
        }

        #endregion

        #region COM port settings
        private void portToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Make sure the port isn't already open
            if (serialPort1.IsOpen)
            {
                MessageBox.Show("The port must be closed before changing the settings.");
                return;
            }
            else
            {
                if (portSettings.ShowDialog() == DialogResult.OK)
                {
                    if (portSettings.selectedPort != "")
                    {
                        // set the serial port to the new settings
                        serialPort1.PortName = portSettings.selectedPort;
                        serialPort1.BaudRate = portSettings.selectedBaudrate;
                        serialPort1.DataBits = portSettings.selectedDataBits;
                        serialPort1.Parity = portSettings.selectedParity;
                        serialPort1.StopBits = portSettings.selectedStopBits;

                        // Show the new settings in the form text line
                        showSettings();
                    }
                    else
                    {
                        MessageBox.Show("Error: Settings form returned with no COM port selected.");
                        return; // bail out
                    }
                }
                else
                {
                    MessageBox.Show("Error: buttonSetup_Click - Settings dialog box did not return Okay.");
                    return; // bail out
                }

                // Open the port
                openPort();
            }          
        }

        // show the settings in the form text line
        private void showSettings()
        {
            this.Text = "AVRUP V1 - " +
                portSettings.selectedPort + " " +
                portSettings.selectedBaudrate.ToString() + "," +
                portSettings.selectedParity + "," +
                portSettings.selectedDataBits.ToString() + "," +
                portSettings.selectedStopBits + " - " +
                portSettings.selectedHandshaking;
            if (serialPort1.IsOpen)
            {
                this.Text += " - Port is open";
            }
            else
            {
                this.Text += " - Port is closed";
            }
        }

        private void openPortToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openPort(); 
        }

        private void openPort()
        {
            try
            {
                if (serialPort1.IsOpen)
                {
                    serialPort1.Close();
                    openPortToolStripMenuItem.Text = "Open Port";
                }
                else
                {
                    serialPort1.Open();
                    openPortToolStripMenuItem.Text = "Close Port";
                }

                showSettings();
            }
            catch (System.Exception ex)
            {
                MessageBox.Show("Error - openPortToolStripMenuItem_Click Exception: " + ex);
            }
        }
        #endregion

        #region AVRUP modes

 /*       // TODO: ADD THE PROCESS CODE TO SEND THE CONTENTS OF THE SEND BOX
        private void buttonSend_Click(object sender, EventArgs e)
        {
            //MessageBox.Show("You want me to send:\n" + richTextBoxSend.Text + "\n?");
            if (serialPort1.IsOpen)
            {
                // TODO: this is not what you want todo, you want to open
                // the avrdude as a process and sent the string as a command line script
                SendASCIIString(richTextBoxSend.Text);
            }
            else MessageBox.Show("The serial port is not open.");
        }
*/
 /*       private void findUploadFileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string filename = "";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                filename = openFileDialog1.FileName;
                if (filename != "")
                {
                    //richTextBoxSend.LoadFile(filename, RichTextBoxStreamType.PlainText);
                    //setToQueued();

                    // strip out "C:"
                    filename = filename.Remove(0, 2);
                    // add it to the AVRDude script string
                    //MessageBox.Show("Yah want I should open: " + filename + "?");
                    avrdudeFilePath = filename;
                    //AVRDudeOut += filename;
                    //richTextBoxSend.Text = AVRDudeOut;
                    //loadAVRDudeParams();   

                    richTextBoxSend.Text = "Filename: " + filename;
                }
            }
            else
            {
                MessageBox.Show("Error loading file.");
            }
        }
*/
 /*       private void buttonMode_Click(object sender, EventArgs e)
        {
            if (upload) // It is in the upload mode so change to serial mode
            {
                serialMode();
            }
            else // It is in the Serial Monitor mode so change to upload mode
            {
                uploadMode();
            }
        }
*/
/*        private void uploadMode()
        {
            // avrdude upload mode
            upload = true;
            
            buttonOkay.Text = "Send to AVRDude";
            buttonCancel.Enabled = true;

            if(serialPort1.IsOpen)
            {
                serialPort1.Close();
            }

            if (xMLData.board == "arduino")
            {
                this.Text = "AVRUP V1 Arduino Mode - " + VersionDate;
            }
            else if (xMLData.board == "butterfly")
            {
                this.Text = "AVRUP V1 Butterfly Mode - " + VersionDate;
            }
            else
            {
                this.Text = "Error in xMLData.board";
            }

            loadAVRDudeParams();
            settingsToolStripMenuItem.Enabled = false;
            openPortToolStripMenuItem.Enabled = false;
            labelSend.Text = "AVRDude Script:";
            //buttonSend.Text = "Upload";
            labelReceive.Text = "AVRDude Response:";
            buttonMode.Text = "Change to serial mode";
            buttonReset.Enabled = false;
        }

        private void serialMode()
        {
            // Serial Monitor mode
            upload = false; 
            // Next choice is Upload mode
            buttonOkay.Text = "Send to Arduino";
            buttonCancel.Enabled = false;

            showSettings();

            settingsToolStripMenuItem.Enabled = true;
            openPortToolStripMenuItem.Enabled = true;

            richTextBoxSend.Clear();
            labelSend.Text = "Send Text:";

            //buttonSend.Text = "Send";

            labelReceive.Text = "Receive Text:";
            buttonMode.Text = "Change to upload mode";
            buttonReset.Enabled = true;

        }
*/
        private void buttonReset_Click(object sender, EventArgs e)
        {
            sendReset();
        }

        // Send reset (Arduino uses DTR or RTS in hardware - DTR in software)
        // Sanguino, Boarduino, and BeAVR use RTS
        // Call this immediately before sending the AVRDude command line
        private void sendReset()
        {
            serialPort1.DtrEnable = false;
            serialPort1.RtsEnable = false;
            //System.Threading.Thread.Sleep(100);
            serialPort1.DtrEnable = true;
            serialPort1.RtsEnable = true;
        }

        private void loadAVRDudeParams()
        {
            //if (xMLData.board == "arduino")
            //{
                //MessageBox.Show("Hello Arduino!");


/*
                AVRDudeOut = "avrdude ";
                AVRDudeOut += "-p " + xMLData.partno;//.ArduinoPartNo;
                AVRDudeOut += " -c " + xMLData.programmer;
                AVRDudeOut += " -P " + xMLData.port;//.COMPort;
                AVRDudeOut += " -b " + xMLData.baudrate;//.ArduinoBaud.ToString();
                //AVRDudeOut += " -F -U " + xMLData.memop;
                AVRDudeOut += avrdudeFilePath;
  */          //}
            /*else if (xMLData.board == "butterfly")
            {
                //MessageBox.Show("Hello Butterfly!");
                buttonReset.Enabled = false;
                buttonReset.Text = "Butterfly Mode";

                AVRDudeOut = "avrdude ";
                AVRDudeOut += "-p " + xMLData.ButterflyPartNo;
                AVRDudeOut += " -c " + xMLData.programmer;
                AVRDudeOut += " -P " + xMLData.port;
                AVRDudeOut += " -b " + xMLData.ButterflyBaud.ToString();
                AVRDudeOut += " -F -U " + xMLData.memop;
                AVRDudeOut += avrdudeFilePath;
            }
            else
            {
                MessageBox.Show("What is a: " + xMLData.board + "?");
            }*/

            // Note that AVRDudeOut is what the process caller uses as
            // the script with the avrdude process
            //richTextBoxSend.Text = AVRDudeOut;
        }
        #endregion

        private void pasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            richTextBoxSend.Paste();
            AVRDudeOut = richTextBoxSend.Text;
        }

        private void boardsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectBoard();
        }

        private void selectBoard()
        {
            // Open dialog with list of boards from xml file names.

            // Load the avrdude parameters from the selected xml file

            openFileDialogBoards.InitialDirectory = System.Environment.CurrentDirectory + "\\Boards";

            if (openFileDialogBoards.ShowDialog() == DialogResult.OK)
            {
                boardXMLFilename = openFileDialogBoards.FileName;
                if (boardXMLFilename != "")
                {

                    // Read the XML data from xmlData.xml
                    //dataXMLIO.appPath = System.Environment.CurrentDirectory + "\\Boards" + filename;
                    
                    //dataXMLIO.appPath = filename;

                    //MessageBox.Show("Yah want I should open: " + dataXMLIO.appPath.ToString() + "?");
                    
/*                    
                    xMLData = dataXMLIO.XMLRead(filename);

                    AVRDudeOut = "avrdude ";
                    AVRDudeOut += "-p " + xMLData.partno;//.ArduinoPartNo;
                    AVRDudeOut += " -c " + xMLData.programmer;

                    if (serialPort1.PortName.ToString() != "") xMLData.port = serialPort1.PortName;
                    AVRDudeOut += " -P " + xMLData.port;//.COMPort;
                    AVRDudeOut += " -b " + xMLData.baudrate;//.ArduinoBaud.ToString();
                    AVRDudeOut += " -F -U " + xMLData.memop;
                    AVRDudeOut += avrdudeFilePath;
*/
                    showParams();
                    //richTextBoxSend.Text = AVRDudeOut;


                    //MessageBox.Show("Yah want I should open: " + filename + "?");
                    //loadAVRDudeParams();

                    //richTextBoxSend.LoadFile(filename, RichTextBoxStreamType.PlainText);
                    //setToQueued();

                    // strip out "C:"
                    //filename = filename.Remove(0, 2);
                    // add it to the AVRDude script string
                    //avrdudeFilePath = filename;
                    //AVRDudeOut += filename;
                    //richTextBoxSend.Text = AVRDudeOut;
                    //loadAVRDudeParams();
                }
            }
            else
            {
                MessageBox.Show("Error loading file.");
            }

        }

        private void selectPortToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Make sure the port isn't already open
            if (serialPort1.IsOpen)
            {
                MessageBox.Show("The port must be closed before changing the settings.");
                return;
            }
            else
            {
                if (portSettings.ShowDialog() == DialogResult.OK)
                {
                    if (portSettings.selectedPort != "")
                    {
                        // set the serial port to the new settings
                        serialPort1.PortName = portSettings.selectedPort;
                        //serialPort1.BaudRate = portSettings.selectedBaudrate;
                        //serialPort1.DataBits = portSettings.selectedDataBits;
                        //serialPort1.Parity = portSettings.selectedParity;
                        //serialPort1.StopBits = portSettings.selectedStopBits;

                        // Show the new settings in the form text line
                        //showSettings();
                        showParams();
                    }
                    else
                    {
                        MessageBox.Show("Error: Settings form returned with no COM port selected.");
                        return; // bail out
                    }
                }
                else
                {
                    MessageBox.Show("Error: selectPortToolStripMenuItem_Click( - Settings dialog box did not return Okay.");
                    return; // bail out
                }

                // Open the port
                //openPort();
            }   
        }

        private void fileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string filename = "";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                filename = openFileDialog1.FileName;
                if (filename != "")
                {
                    //richTextBoxSend.LoadFile(filename, RichTextBoxStreamType.PlainText);
                    //setToQueued();

                    // strip out "C:"
                    filename = filename.Remove(0, 2);
                    // add it to the AVRDude script string
                    //MessageBox.Show("Yah want I should open: " + filename + "?");
                    avrdudeFilePath = filename;
                    //AVRDudeOut += filename;
                    //richTextBoxSend.Text = AVRDudeOut;
                    //loadAVRDudeParams();   

                    //richTextBoxSend.Text = "Filename: " + filename;
                    showParams();
                }
            }
            else
            {
                MessageBox.Show("Error loading file.");
            }
        }

        void setAVRDudeOut()
        {
            xMLData = dataXMLIO.XMLRead(boardXMLFilename);

            AVRDudeOut = "avrdude ";
            AVRDudeOut += "-p " + xMLData.partno;//.ArduinoPartNo;
            AVRDudeOut += " -c " + xMLData.programmer;

            if (serialPort1.PortName.ToString() != "") xMLData.port = serialPort1.PortName;
            AVRDudeOut += " -P " + serialPort1.PortName;// xMLData.port;//.COMPort;
            AVRDudeOut += " -b " + xMLData.baudrate;//.ArduinoBaud.ToString();
            AVRDudeOut += " -F -U " + xMLData.memop;
            AVRDudeOut += avrdudeFilePath;

        }

        void showParams()
        {
            setAVRDudeOut();
            //richTextBoxSend.Text = "Filename: " + avrdudeFilePath + "\n";
            //richTextBoxSend.Text += "COM Port: " + serialPort1.PortName + "\n";
            richTextBoxSend.Text += "avrdude command line: " + AVRDudeOut + "\n";

        }

    }
}

